Unit AMMJR_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMMJR(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Real; var IB :Array of Integer;
                var JB :Array of Integer; var BN :Array of Real;
                var IC :Array of Integer; var JC :Array of Integer;
                NP :Integer; NQ :Integer; NR :Integer;
                var CN :Array of Real; var X :Array of Real); 
implementation

procedure AMMJR(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Real; var IB :Array of Integer;
                var JB :Array of Integer; var BN :Array of Real;
                var IC :Array of Integer; var JC :Array of Integer;
                NP :Integer; NQ :Integer; NR :Integer;
                var CN :Array of Real; var X :Array of Real);
var
I,ICA,ICB,J,L,IAA,IAB,IBA,IBB,KP,K,JP :Integer;
A :Real;
label
_10,_20,_30,_40,_50;
begin

{          = -  }
{             .      }
{        ,      RR()U. -  }
{              N  }


{   I, J, N -         }
{                  RR()U;  }

{   I, J, N -         }
{                  RR()U; }

{       I, J -       - }
{                 RR()U; }

{           N -      (: ); }

{           NQ -          }
{                 (: ); }

{           NR -      (: ); }

{           N -   ,   -   }
{                      -  }
{                  I, J; }

{             -     NR, -  }
{                      }


{            I   }
{      ,     }

for I:=1 to NP do
 begin
  ICA := IC[I-1];
  ICB := IC[I+0]-1;
  if ( ICB < ICA ) 
   then goto _50;

{             }

  for J:=ICA to ICB do
   begin
    L := JC[J-1];
_10:
    X[L-1] := 0.0E0;
   end;

{            I     }

  IAA := IA[I-1];
  IAB := IA[I+0]-1;
  for JP:=IAA to IAB do
   begin
    J := JA[JP-1];
    A := AN[JP-1];

{          I     J  }
{      ,   J   }

    IBA := IB[J-1];
    IBB := IB[J+0]-1;
    if ( IBB < IBA ) 
     then goto _30;
    for KP:=IBA to IBB do
     begin
      K := JB[KP-1];
_20:
      X[K-1] := X[K-1]+A*BN[KP-1];
     end;
_30:
   end;

{         N }

  for J:=ICA to ICB do
   begin
    L := JC[J-1];
_40:
    CN[J-1] := X[L-1];
   end;
_50:
 end;
end;

end.
